rawset(_G, "valid", function(th)
  return th and th.valid
end)

addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_DETON
	or i.type == MT_CRUSHCLAW
	or i.type == MT_FACESTABBERSPEAR
		if not valid(t)
			return nil
		end
		if not valid(t.player)
			return nil
		end
		local p = t.player
		p.powers[0] = 0
		p.powers[2] = 0
		p.powers[3] = 0
		p.powers[12] = 0
		p.rings = 0
		return true
	end
end, MT_PLAYER)//instantly kills you if you touch a deton or a crushtacean's claw; don't forget to put Flame in the credits for this hook and the rawset

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETJAW)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 175
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		P_SpawnMissile(m, m.target, MT_TORPEDO2)
		S_StartSound(m, sfx_rlaunc)
		m.shootwait = 0
	end
end, MT_JETJAW)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_ROBOHOOD)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 28
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ARROW)
		S_StartSound(m, sfx_s3ka0)
		m.shootwait = 0
	end
end, MT_ROBOHOOD)

addHook("MobjDeath", function(m)
		S_StartSound(m, sfx_s3k4e)
end, MT_EGGGUARD)

addHook("TouchSpecial", function(s, t)
	if t.player.rings > 4
		t.player.rings = t.player.rings-5
		S_StartSound(t, sfx_antiri)
	elseif t.player.rings < 4
	and t.player.rings > 0
		t.player.rings = 0
		S_StartSound(t, sfx_antiri, true)
	end
end, MT_EGGSHIELD)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_MINUS)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.target
	and m.state == S_MINUS_AERIAL4
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_MINUS)

addHook("TouchSpecial", function(s, t)
	if t.player.rings > 0
		t.player.rings = t.player.rings-1
		S_StartSound(t, sfx_antiri, true)
	end
end, MT_CANARIVORE_GAS)

addHook("MobjSpawn", function(m)
	m.shootwait = 175
	m.shootwait2 = 0
end, MT_UNIDUS)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 245
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		m.shootwait2 = 5
		m.shootwait = 0
	end
	if m.shootwait2 > 0
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
	and P_RandomRange(1, 20) == 1
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait2 = m.shootwait2-1
	end
end, MT_UNIDUS)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_PYREFLY)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_PYREFLY_FIRE)
		S_StartSound(m, sfx_fire)
		m.shootwait = 0
	end
end, MT_PYREFLY)

addHook("MobjThinker", function(m)
	if m.cusval >= 11
		m.cusval = 10
	end
end, MT_PTERABYTE)//makes it impossible to mash out of pterabytes, though I hear that this might not apply to the android port

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETTGUNNER)

addHook("MobjThinker", function(m)
	if (m.flags2 & MF2_AMBUSH)
		m.shootwait = m.shootwait+1
		if m.shootwait >= 105
		and m.target
		and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
			P_SpawnMissile(m, m.target, MT_JETTBULLET)
			S_StartSound(m, sfx_s3k4d)
			m.shootwait = 0
		end
	end
end, MT_JETTGUNNER)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETTBOMBER)

addHook("MobjThinker", function(m)
	if (m.flags2 & MF2_AMBUSH)
		m.shootwait = m.shootwait+1
		if m.shootwait >= 35
			A_TrapShot(m, MT_MINE, 270)
			S_StartSound(m, sfx_s3k51)
			m.shootwait = 0
		end
	end
	if not (m.flags2 & MF2_AMBUSH)
		m.shootwait = m.shootwait+1
		if m.shootwait >= 35
		and m.target
		and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 100*FRACUNIT
			A_DropMine(m, -8, 0)
			S_StartSound(m, sfx_s3k51)
			m.shootwait = 0
		end
	end
end, MT_JETTBOMBER)

addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_DRAGONMINE
		return false
	end
end, MT_JETTBOMBER)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
	m.shootwait2 = 0
end, MT_PENGUINATOR)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 35
	and m.state == S_PENGUINATOR_SLIDE5
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		m.shootwait2 = 5
		m.shootwait = 0
	end
	if m.shootwait2 > 0
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
	and P_RandomRange(1, 8) == 1
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait2 = m.shootwait2-1
	end
end, MT_PENGUINATOR)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_CRAWLACOMMANDER)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 105
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_CRAWLACOMMANDER)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_HANGSTER)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_HANGSTER)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_POINTY)

addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_POINTY)

addHook("ShouldDamage", function(t, i, s, d, dt)
	return false
end, MT_SPINBOBERT)

addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_CACOFIRE
		return false
	end
end, MT_CACOLANTERN)

addHook("MobjSpawn", function(m)
	if gamemap == 474//Kaizo SRB2's ACZ3
	or gamemap == 654//PAIN's ACZ3
		m.info.deathstate = S_BUMBLEBORE_DIE
	else
		m.info.deathstate = S_TNTBARREL_EXPLA
	end
end, MT_BUMBLEBORE)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_GOOMBA)

addHook("MobjThinker", function(m)
	if m.health == 2
		m.sprite = SPR_GOOF
	end
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.health == 2
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		A_HoodFire(m, MT_FIREBALL)
		S_StartSound(m, sfx_mario7)
		m.shootwait = 0
	end
end, MT_GOOMBA)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_BLUEGOOMBA)

addHook("MobjThinker", function(m)
	if m.health == 2
		m.sprite = SPR_GOOF
	end
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.health == 2
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		A_HoodFire(m, MT_FIREBALL)
		S_StartSound(m, sfx_mario7)
		m.shootwait = 0
	end
end, MT_BLUEGOOMBA)

addHook("TouchSpecial", function(s, t)
    if t.player.nightstime
    and t.player.nightstime > 10*TICRATE
        t.player.nightstime = t.player.nightstime-(10*TICRATE)
    elseif t.player.nightstime
    and t.player.nightstime <=10*TICRATE
    and t.player.nightstime > 1
        t.player.nightstime = 1
    end
end, MT_SHLEEP)